#!/usr/bin/perl
# @see http://www.kusastro.kyoto-u.ac.jp/~baba/wais/pagerank.html
$|++;
use strict;

# vZ~邽߂̎l
my $delta = 1 / 100;# %



# f[^ǂݍ
my @url_list = ();
my $mat = [];
print STDERR "Reading data file";
die "Failed to open data file."
    unless open( my $fh, "<link_matrix.txt");
while(<$fh>) {
    print STDERR ".";
    my @column = split ',';
    my $idx = shift @column;  # index
    my $url = shift @column;  # url
    $url_list[$idx] = $url;
    my $j = 0; map {
        # ]us
        $mat->[$j]->[$idx] = $idx == $j ? 0 : $_; # gւ̃N͍lȂ
    $j++ } @column;
}
close $fh;
printf STDERR " %s pages\n", scalar @url_list;
mat_normalize( $mat );



# Ƃ(Ȃꍇ͍ő 100 )
for (1..100) {
    printf STDERR "(LOOP:%d)", $_;
    $mat = mat_double( $mat );
    last if is_converged( $mat );
}
printf STDERR "\n";

# vZ(PageRank)̕\
map {
    printf STDOUT "%d,%s,%f,%f\n", $_, $url_list[$_], $mat->[$_]->[0], $mat->[$_]->[0] * scalar @$mat;
} 0..( scalar @$mat - 1 );

exit;



### vZ
my $prev_mat = undef;
sub is_converged {
    my $mat = shift;
    unless( $prev_mat ) {
        printf STDERR "\n";
        $prev_mat = $mat;
        return 0;
    }
    map {
        my $p = $prev_mat->[$_]->[0];
        next if $p == 0;
        my $d = ( $p - $mat->[$_]->[0] ) / $p;
        if( $delta < abs( $d ) ) {
            printf STDERR "(d=%f)\n", $d;
            $prev_mat = $mat;
            return 0;
        }
    } 0..( scalar @$mat - 1 );
    printf STDERR "\n";
    return 1;
}

# ڊmsɐK
sub mat_normalize {
    my $mat = shift;

    # e̍vlvZ
    my @row_total = ();
    {   print STDERR "TTL.";
        my $i = 0; map {
            my $j = 0; map {
                $row_total[$j] += $_;
            $j++ } @$_;
        $i++ } @$mat;
    }

    # N̏oĂȂy[WĂH
    {   print STDERR "CHK.";
        my $i = 0; map {
            die "\nPage:$i has no outer link\n" if $_ == 0;
        $i++ } @row_total;
    }

    # łĐK
    {   print STDERR "DIV.";
        my $i = 0; map {
            my $mat_i = $_;
            my $j = 0; map {
                $mat_i->[$j] /= $row_total[$j];
            $j++ } @$mat_i;
        $i++ } @$mat;
    }
}

# s̊|Z
sub mat_double {
    my $mat = shift;
    my $ret = [];
    {   print STDERR "MUL.";
        my $i = 0; map { print STDERR "+";
            my $mat_i = $_;
            my $j = 0; map { #print STDERR "-";
                my $sum = 0;
                map {
                    $sum += $mat_i->[$_] * $mat->[$_]->[$j];
                } 0..( scalar @$mat - 1 );
                $ret->[$i]->[$j] = $sum;
            $j++ } @$mat_i;
        $i++ } @$mat;
    }
    mat_normalize( $ret );
    $ret;
}
